/* bxbasm : Asminput.c : alpha version */
/* ----- function prototypes ----- */
#include "prototyp.h"


void Header()
{
    open_destin();
	/**/
    writeln(";\t*************BxbAsm Compiler*************");
    writeln(";\tCopyright: sarbayo (c) 2004");
    writeln("; =========================================================================");
    writeln("  .386                       ; use 386 instructions");
    writeln("  .model flat, stdcall       ; Win32 memory model");
    writeln("  option casemap:none        ; case sensitive");
    writeln("; =========================================================================");
    writeln("; BXB Function Prototypes:");
    writeln("; =========================================================================");
    writeln("  dblArryElement   proto");
    writeln("  quadArryElement  proto");
    writeln("  freeArray  proto");
    writeln("    ;proto");
    writeln("; =========================================================================");
    writeln("  include \\Masm32\\Bxbasm\\BXB.inc");
    writeln("; -------------------------------------------------------------------------");
    writeln("; =========================================================================");
    writeln(";  INITIALIZED DATA");
    writeln("; =========================================================================");
    writeln(" .data");
	/**/
    Prolog();
    Build_arrays();
}
/*---------- end Header ----------*/


void Prolog()				/* Write the Prolog */
{
    ScanVars();				/* pre-scan for quoted strings */
	/**/
    writeln("; =========================================================================");
    writeln(";  UNINITIALIZED DATA");
    writeln("; =========================================================================");
    writeln(" .data?");
    writeln("\tsystem_time SYSTEMTIME  <>\t\t\t;current date & time");
    writeln("\tsa  SECURITY_ATTRIBUTES  <>");
    writeln("\tcsbi  CONSOLE_SCREEN_BUFFER_INFO  <>");
    writeln("\tiCOL\t\tdd\t?");
    writeln("\tiROW\t\tdd\t?");
    writeln("\tiYear\t\tdd\t?");
    writeln("\tiMonth\tdd\t?");
    writeln("\tiDay\t\tdd\t?");
    writeln("\tiHour\t\tdd\t?");
    writeln("\tiMinute\tdd\t?");
    writeln("\tiSecond\tdd\t?");
    writeln("\tiMilli\tdd\t?");
    writeln("\thStdHandle\t\tdd\t?");
    writeln("\tIntString\tdb\t12\t\tdup(?)\t; integer string");
    writeln("\tFltString\tdb\t28\t\tdup(?)");
    writeln("\tBffrInput\tdb\tBUFSIZE\tdup(?)");
    writeln("\tiohandles\tDD\t99\t\tdup(?)");
    writeln("\tiobuffers\tDD\t99\t\tdup(?)");
    writeln("\tiLVAR\t\tdd\t?");
    writeln("\tiRVAR\t\tdd\t?");
    writeln("\tqLVAR\t\tdq\t?");
    writeln("\tqRVAR\t\tdq\t?");
    writeln("\tarray_mtrx\t\tDW\t60\tdup(?)");
	/**/
    load_tmpdata();
	/**/
    writeln("; =========================================================================");
    writeln(" .code");
    writeln("; =========================================================================");
    writeln(" start:");
    writeln("; =========================================================================");
    writeln("  invoke Main");
    writeln("  invoke ExitProcess, NULL");
    writeln("; =========================================================================");
    writeln("; --------------------------------------------------");
    writeln("Main proc");
    writeln("; --------------------------------------------------");
    writeln("  pushad");
    writeln("  call Do_initialize");
}
/*---------- end Prolog ----------*/


void SystemConst()
{
    writeln("; --------------------------------------------------");
    writeln("; Do Not Delete !!!:  Constants and system variables");
    writeln("; --------------------------------------------------");
    writeln("\tinteger    dd  0");
    writeln("\tx87buff    dq  0");
    writeln("; --------------------------------------------------");
}
/*---------- end SystemConst ----------*/


void Epilog()			/* Write the Epilog */
{
    writeln(";");
    PostLabel("DONE");
    writeln("  ; --------------------------------------------------");
    writeln("  ; --------------------------------------------------");
    writeln("Alldone:");
    writeln("  invoke StdIn, addr BffrInput, BUFFR_SIZ   ; pause");
    writeln("  popad");
    writeln("  ret                                       ; return to windows");
    writeln("  ; --------------------------------------------------");
    writeln("Main endp");
    writeln("; =========================================================================");
		/**/
		/* --- write functions --- */
    Do_functions();
		/**/
		/* --- mark end of program --- */
    writeln("; =========================================================================");
    writeln("end start");
    writeln("; =========================================================================");
    writeln("; =========================================================================");
    fclose(f_out);
    printf("Lines compiled: %d\n", nrows);
    printf("Done.\n");
}
/*---------- end Epilog ----------*/


void Sav_String(char *Name)
{   char varname[VAR_NAME];

    strcpy(varname, Name);
    strcat(varname, "$");
    if(check_VarName(varname) == 0)
    {   s_write_str("\t");
        s_write_str(varname);
        s_writeln("\t\tDD\t?");
    }
}
/*---------- end Sav_String ----------*/


void open_destin()
{   char ch, dot='.', destin[PATH];
    int ii;

    strcpy(destin, s_holder);			/* copy source file name */
    ii = 0;
    ch = '\0';
    while(ch != dot)
    {   ch = s_holder[ii];			/* make source.bas = source. */
        ii++;
    }
    destin[ii] = '\0';
    strcat(destin, "asm");			/* append "asm" to filename */
    strcpy(t_holder, destin);			/* copy asm source filename */
		/**/
    f_out = fopen(destin,"w");	 /* open destination file (write) */
    printf("Destination file: %s\n",destin);
		/**/
    s_datatemp = fopen("sdatatmp.tmp","w");		/* open temp file */
    i_datatemp = fopen("idatatmp.tmp","w");		/* open temp file */
    f_datatemp = fopen("fdatatmp.tmp","w");		/* open temp file */
    x_datatemp = fopen("xdatatmp.tmp","w");		/* open temp file */
		/**/
    s_writeln("\t_var_start\tdd\t?");		/* string data */
    i_writeln("\t_int_start\tdd\t?");		/* integer data */
    f_writeln("\t_flt_start\tdd\t?");		/* float data */
    x_writeln("\t_arry_start\tdd\t?");		/* arrays data */
}
/*---------- end open_destin ----------*/


void ScanVars()				/* identify and write all variables */
{   char ch, varname[VAR_NAME];
    int pi, ii;
    
    line_ndx = 0;
    while(line_ndx < nrows)
    {   get_token();
        e_pos = 0;
        s_pos = 0;
		/**/
        switch(token)
        {   case 1:    			/* --- LET: statement --- */
                ScanLet();
                break;
            case 2:    			/* --- CLEAR: statement --- */
                ScanPrint();
                break;
            case 3:    			/* --- LOCATE: statement --- */
                ScanParam();
                break;
            case 4:	    		/* --- PRINT: statement --- */
                ScanPrint();
                break;
            case 5:    			/* --- GOTO: statement --- */
            case 9:    			/* --- GOSUB: statement --- */
                ScanJump();
                break;
            case 11:			/* --- FOR: statement --- */
                ScanFor();
                break;
            case 13:			/* --- IF: statement --- */
            case 14:			/* --- ELSEIF: statement --- */
                ScanIf();
                break;
            case 17:			/* --- INPUT: statement --- */
            case 18:			/* --- LINE INPUT: statement --- */
                ScanPrint();
                break;
            case 19:			/* --- OPEN: statement --- */
                ScanOpen();
                break;
            case 21:			/* --- WRITE: statement --- */
                ScanWrite();
                break;
            case 22:			/* --- FIELD: statement --- */
                ScanField();
                break;
            case 23:			/* --- LSET: statement --- */
            case 24:			/* --- RSET: statement --- */
                ScanLet();
                break;
            case 25:			/* --- PUT: statement --- */
            case 26:			/* --- GET: statement --- */
                ScanPut();
                break;
            case 27:			/* --- CHDIR: statement --- */
            case 28:			/* --- MKDIR: statement --- */
            case 29:			/* --- RMDIR: statement --- */
            case 30:			/* --- KILL: statement --- */
                ScanPrint();
                break;
            case 31:			/* --- NAME/RENAME: statement --- */
                ScanRename();
                break;
            case 32:			/* --- FILES: statement --- */
                ScanFiles();
                break;
            case 33:			/* --- SHELL: statement --- */
                ScanShell();
                break;
            case 34:	    		/* --- RANDOM: statement --- */
                ScanParam();
                break;
            case 35:	    		/* --- READ: statement --- */
                ScanFInput();
                break;
            case 37:	    		/* --- WHILE: statement --- */
                ScanIf();
                break;
            case 43:	    		/* --- LPRINT: statement --- */
                ScanLPrint();
                break;
            case 44:	    		/* --- COLOR: statement --- */
                ScanParam();
                break;
            case 46:	    		/* --- DIM: statement --- */
                ScanDim();
                break;
            case 47:	    		/* --- ERASE-FREE: statement --- */
                ScanPrint();
                break;

        }
        line_ndx++;
    }
    SystemConst();				/* write system constants */
	/**/
    for(ii=0; ii < VarNdxCnt; ii++)		/* clear var name index */
    {   free(VarIndx[ii]);
    }
    free(VarIndx);
}
/*---------- end ScanVars ----------*/


void ScanLet()
{   char ch, varname[VAR_NAME];
    int pi, type, ab_code=5, x=line_ndx;

    pi = e_pos;
    strcpy(varname, get_varname());			/* get varname */
	/**/
    type = get_vtype(pi);				/* get variable type */
    if(type == 1)						/* numeric expressions */
    {   ScanNumeric(varname);
    }
    else if(type == 3)					/* strings */
    {   ScanString(varname);
    }
    else if(type == 6)					/* string array */
    {   ScanStrArray();
    }
    else if(type >= 7)					/* numeric array */
    {   ScanNumArray(varname, type);
    }
    else
    {   a_bort(ab_code, x);
    }
}
/*---------- end ScanLet ----------*/


void ScanString(char *Name)
{   char ch, varname[VAR_NAME];
    int pi, len, type;

    strcpy(varname, Name);
    Sav_String(Name);
    len = strlen(p_string);
    pi = e_pos;
    pi = get_rightExp(pi);			/* jump pi over this operator */
    ch = p_string[pi];
    while((ch != '\n') && (pi < len))
    {   e_pos = pi;
        if(ch == '\"')				/* found a quoted string */
        {   GetNewVar();				/* get new varname */
        }
        else if(isalpha(ch))
        {   strcpy(varname, get_varname());		/* get varname */
			/**/
            type = get_vtype(pi);
            if(type == 6)
            {   pi = e_pos;
                pi = get_paren(pi, len);
                ScanArrayParam();
            }
            else
            {   Sav_String(varname);
            }
        }
        else if(isdigit(ch))			/* a string function number */
        {   len = scanStr_funct(len);
        }
        pi = e_pos;
        pi = get_rightExp(pi);
        ch = p_string[pi];
    }
}
/*---------- end ScanString ----------*/


int scanStr_funct(int len)
{   char ch, varname[VAR_NAME];
    int pi, type;

    pi = e_pos;
    pi = get_paren(pi,len);
    if(pi >= len)
    {   e_pos = pi;				/* a$ = INKEY$, TIME$, DATE$ */
        return len;
    }
    pi++;
    pi = iswhite(pi);
    ch = p_string[pi];
    while(ch != ')')
    {   ch = p_string[pi];
        e_pos = pi;
        if(ch == '\"')				/* found a quoted string */
        {   GetNewVar();				/* get new varname */
        }
        else if((isdigit(ch)) || (strchr("-.", ch)))
        {   GetNewTmp();				/* get new temp varname */
        }
        else if(isalpha(ch))				/* a variable name */
        {   strcpy(varname, get_varname());	/* get varname */
            pi = e_pos;
            type = get_vtype(pi);			/* get variable type */
            if(type == 3)				/* string variables */
            {   Sav_String(varname);
            }
            else						/* numeric variables */
            {   len = strlen(varname);
                s_pos = pi - len;
                type = get_Nvtype(pi);
                Sav_Destin(type, varname);	/* save variable name */
            }
        }
        pi = e_pos;
        len = strlen(p_string);
        ch = p_string[pi];
  /* printf("%sch=%c< pi=%d\n", p_string, ch, pi); */

        if(strchr("$, %!#@", ch))
        {   pi++;
        }
    }
    e_pos = pi;
    return len;
}
/*---------- end scanStr_funct ----------*/


void ScanPrint()
{   char ch, varname[VAR_NAME];
    int pi, type, len, ival, ab_code=7, x=line_ndx;

 /* printf("scanprint: %s", p_string); */
    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);
    ch = p_string[pi];
    if(ch == '#')
    {   if(token == 4)
        {   ScanFPrint();		/* PRINT# statement */
        }
        else
        {   ScanFInput();
        }
        return;
    }
    while((pi < len) && (ch != '\n'))
    {
  /* printf("ch=%c pi=%d len=%d\n", ch, pi, len); */
        e_pos = pi;
		/**/
        if(ch == '\"')				/* found a quoted string */
        {   GetNewVar();			/* get new varname */
        }
        else if(ch == '?')			/* math function: ?1(num) */
        {   e_pos = pi + 1;
            ival = (int) get_avalue();
            if((ival == 10) || (ival == 11) || (ival == 29))
            {   pi = len;				/* LOC, LOF, EOF */
                e_pos = pi;
            }
            else					/* any other function */
            {   pi = get_paren(pi, len);	/* ?num(string$) */
                pi++;
                e_pos = pi;
                ScanMathFunc(len);
            }
        }
        else if(isalpha(ch))
        {   strcpy(varname, get_varname());	/* get varname */
            s_pos = pi;
            pi = e_pos;
            type = get_vtype(pi);			/* get variable type */
            if(type == 3)				/* string variables */
            {   Sav_String(varname);
            }
            else if(type == 6)			/* string array */
            {   pi = get_paren(pi, len);
                ScanArrayParam();
            }
            else if(type >= 7)			/* numeric array */
            {   Scan_Array(varname, type);
            }
            else						/* numeric variables */
            {   len = strlen(varname);
                s_pos = pi - len;
                type = get_Nvtype(pi);
                Sav_Destin(type, varname);	/* save variable name */
            }
        }
        else if(isdigit(ch))			/* a string function number */
        {   pi = get_NextOp(pi);
            ch = p_string[pi];
       /* printf("ch=%c pi=%d len=%d\n", ch, pi, len); */

            if(ch == '(')			/* is it a: 2(string) */
            {   len = scanStr_funct(len);
            }
            else					/* or: 2+2 */
            {   GetNewTmp();			/* get new temp varname */
            }
        }
        pi = e_pos;
        ch = p_string[pi];
        len = strlen(p_string);
        if(strchr(":; ,)(", ch))		/* jump over punctuation */
        {   pi = get_rightExp(pi);		/* get to next alpha or string */
            ch = p_string[pi];
        }
        else if(strchr("$%!#@", ch))	/* jump over var types */
        {   pi = get_rightExp(pi);		/* get to next alpha or string */
            ch = p_string[pi];
        }
        else if(strchr("+-*/^", ch))      /* jump over operators */
        {   pi = get_rightExp(pi);	/* get to next alpha or string */
            ch = p_string[pi];
        }
        e_pos = pi;
    }
 /* printf("ScanPrint: %s", p_string); */
}
/*---------- end ScanPrint ----------*/


void GetNewVar()
{   char ch, NVar[12], a_string[BUFSIZE], count[4];
    int pi, x=0, len, ab_code=23;

    len = strlen(p_string);
    pi = e_pos;
    s_pos = pi;
  /* --- get new varname --- */
    strcpy(NVar, NewVarname());
	/**/
    write_str("\t");
    write_str(NVar);		/* NVar  DB  # */
    write_str("\t\tDB\t");
	/**/
    pi++;
    ch = p_string[pi];
    while((ch != '\"') && (pi < len))		/* copy up to quote */
    {   a_string[x] = ch;
        x++;
        pi++;
        ch = p_string[pi];
    }
    a_string[x] = '\0';
    if(pi >= len)				/* Error: missing closing quote */
    {   x = line_ndx;
        a_bort(ab_code, x);
    }
    e_pos = pi;
    len = strlen(a_string);
    if(len == 0)
    {   writeln("NULL");
    }
    else
    {   write_str("\'");
        write_str(a_string);
        writeln("\',0");
    }
  /* --- save varname in array --- */
    StorVar(NVar);
    pi = e_pos;
    ch = p_string[pi];
    if(strchr(":;,", ch))
    {   pi++;
        e_pos = pi;
    }
}
/*---------- end GetNewVar ----------*/


void StorVar(char *name)
{   char ch, varname[12];
    int pi, x=0, ii, len;
    unsigned size;

    strcpy(varname, name);
    len = strlen(varname);
    ii = (s_pos + len);		/* how many chars to xfer */
    if(s_pos > 0)
    {   for(;x < s_pos; x++)
        {   s_holder[x] = p_string[x];
        }
        x = 0;
    }
    for(pi=s_pos; pi < ii; pi++,x++)
    {    s_holder[pi] = varname[x];	/* copy varname */
    }
    x = pi; 
    s_pos = pi;
    pi = e_pos;
    pi++;
    ch = p_string[pi];
    while(ch != '\0')
    {   s_holder[x] = p_string[pi];
        x++;
        pi++;
        ch = p_string[pi];
    }
    s_holder[x] = '\0';
    strcpy(p_string, s_holder);

/* --- save p_string to array --- */
    x = strlen(p_string);
    len = strlen(array1[line_ndx]);
    if(x > len)
    {  size = (x+1);
       ii = line_ndx;
       array1[ii] = realloc(array1[ii], size * sizeof(char));
    }
    strcpy(array1[line_ndx], p_string);   /* store to array */
    e_pos = s_pos;
}
/*---------- end StorVar ----------*/


char *NewVarname()		/* generate a unique varname */
{   char Val[6];
    static char NVar[12];

    var_count++;
    strcpy(NVar, "VARX");
    sprintf(Val, "%d", var_count);
    strcat(NVar, Val);
    strcat(NVar, "$");
    return NVar;
}
/*---------- end NewVarname ----------*/


void load_tmpdata()
{   char tmp_string[BUFSIZE];
    int x;
    FILE *datatemp;

    f_writeln("\t_var_endzz\tdd\t?");
    f_writeln("\tStringBffr\tdb\tMBUFSIZE\tdup(?)");

		/**/
    fclose(s_datatemp);
    fclose(i_datatemp);
    fclose(f_datatemp);
    fclose(x_datatemp);
		/**/
    datatemp = fopen("sdatatmp.tmp","r");		/* open temp file */
    while(!feof(datatemp))
    {   fgets(tmp_string, BUFSIZE, datatemp);
        if(!feof(datatemp))
        {   write_str(tmp_string);		/* write data to file */
        }
        tmp_string[0] = '\0';
    }
    fclose(datatemp);
		/**/
    datatemp = fopen("idatatmp.tmp","r");		/* open temp file */
    while(!feof(datatemp))
    {   fgets(tmp_string, BUFSIZE, datatemp);
        if(!feof(datatemp))
        {   write_str(tmp_string);		/* write data to file */
        }
        tmp_string[0] = '\0';
    }
    fclose(datatemp);
		/**/
    datatemp = fopen("fdatatmp.tmp","r");		/* open temp file */
    while(!feof(datatemp))
    {   fgets(tmp_string, BUFSIZE, datatemp);
        if(!feof(datatemp))
        {   write_str(tmp_string);		/* write data to file */
        }
        tmp_string[0] = '\0';
    }
    fclose(datatemp);
		/**/
    datatemp = fopen("xdatatmp.tmp","r");		/* open temp file */
    while(!feof(datatemp))
    {   fgets(tmp_string, BUFSIZE, datatemp);
        if(!feof(datatemp))
        {   write_str(tmp_string);		/* write data to file */
        }
        tmp_string[0] = '\0';
    }
    fclose(datatemp);
		/**/
    x = remove("sdatatmp.tmp");   		/* if '0', successful */
    x = remove("idatatmp.tmp");   		/* if '0', successful */
    x = remove("fdatatmp.tmp");   		/* if '0', successful */
    x = remove("xdatatmp.tmp");   		/* if '0', successful */

}
/*------- end load_tmpdata ----------*/


void ScanFor()
{   char ch, varname[VAR_NAME];
    int pi, type, len, ab_code=9, x=line_ndx;

    pi = 0;
    e_pos = pi;
    strcpy(varname, get_varname());			/* get varname */
	/**/
    type = get_vtype(pi);				/* get variable type */
    if(type == 1)						/* numeric expressions */
    {   LexFor(varname);
        pi = e_pos;
        e_pos = pi + 2;					/* skip over: TO */
        LexTo();
        pi = e_pos + 4;					/* skip over: STEP */
        len = strlen(p_string);
        if(len > pi)					/* if: STEP n */
        {   e_pos = pi;
            LexStep(len);
        }
        else
        {   e_pos = len;
            defaultStep(len);			/* create default STEP n */
        }
    }
    else
    {   a_bort(ab_code, x);
    }
}
/*---------- end ScanFor ----------*/


void ScanIf()
{   char ch, varname[VAR_NAME];
    int pi, len, type;

    pi = 0;
    ch = p_string[pi];
    len = strlen(p_string);
    while((ch != '\n') && (pi < len))
    {   pi = iswhite(pi);
        ch = p_string[pi];
        e_pos = pi;
        if(ch == '\"')				/* found a quoted string */
        {   GetNewVar();			/* get new varname */
        }
        else if(isalpha(ch))
        {   strcpy(varname, get_varname());	/* get varname */
            pi = e_pos;
            type = get_vtype(pi);			/* get variable type */
            if(type == 3)
            {   Sav_String(varname);
            }
            else
            {   if(strcmp(varname, "EOF") != 0)		/* not an EOF(f) */
                {   len = strlen(varname);
                    s_pos = pi - len;
                    type = get_Nvtype(pi);
                    Sav_Destin(type, varname);	/* save destination name */
                }
                else
                {   pi++;					/* it's an EOF(f) */
                    pi = get_paren(pi, len);
                    e_pos = pi;
                }
            }
        }
        else if(isdigit(ch))
        {   GetNewTmp();				/* get new temp varname */
        }
        pi = e_pos;
        len = strlen(p_string);
        pi = get_rightExp(pi);
        ch = p_string[pi];
    }
}
/*---------- end ScanIf ----------*/


void ScanFiles()
{   char ch, temp[BUFSIZE];
    int pi, len;

    strcpy(temp, "\"dir ");
    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);
		/**/
    if(pi < len)
    {   ch = p_string[pi];
        if(ch == '\"')
        {   p_string[pi] = ' ';
            strcat(temp, p_string);
        }
        else
        {   strcat(temp, p_string);
        }
    }
    else
    {   strcat(temp, "\"\n");
    }
    strcpy(p_string, temp);
    e_pos = 0;
    GetNewVar();					/* get new varname */
}
/*---------- end ScanFiles ----------*/


void ScanShell()
{   char ch, temp[BUFSIZE];
    int pi, len;

    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);
		/**/
    if(pi < len)
    {   strcpy(temp, p_string);
    }
    else
    {   strcpy(temp, "\"command\"");
    }
    strcpy(p_string, temp);
    e_pos = 0;
    GetNewVar();					/* get new varname */
}
/*---------- end ScanShell ----------*/


void ScanRename()
{   char temp[6];
    int pi, len, mark;

    len = strlen(p_string);
    pi = e_pos;
		/**/
    strcpy(temp, "AS ");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;
    pi = mark;
    if(pi < len)
    {   p_string[pi] = ',';
        p_string[(pi+1)] = ' ';
    }
    e_pos = 0;
    ScanPrint();
}
/*---------- end ScanRename ----------*/


void ScanDim()
{   char ch, varname[VAR_NAME], temp[BUFSIZE];
    int pi, len, xcnt=0, type, ii, bool, ab_code=20, x=line_ndx;
    unsigned size;

    len = strlen(p_string);
    pi = e_pos;
    strcpy(varname, get_varname());
		/**/
    type = get_vtype(pi);
    if(type == 6)
    {   strcat(varname, "$");
    }
    else if(type > 6)
    {   switch(type)
        {   case 7:
                strcat(varname, "L");
                break;
            case 8:
                strcat(varname, "F");
                break;
            case 9:
                strcat(varname, "D");
                break;
            case 10:
                strcat(varname, "Q");
                break;
        }
        s_pos = pi;
        StorNVar(varname);				/* save array name */
    }
    if(check_VarName(varname) != 0)	/* duplicate varname, make */
    {   a_bort(ab_code,x);		/* sure varnames are not array names */
    }
    if(check_arrayName(varname) == 0)	/* register this array-name */
    {   x_write_str("\t");
        x_write_str(varname);
        x_writeln("\t\tDD\t?");
        x_writeln("\t\t\tDW\t61\tdup(?)");
		/**/
        pi = e_pos;
        pi = get_paren(pi, len);
        s_pos = pi;
        xcnt = get_paramsCount(pi, len);	/* get params count */
        sprintf(temp, "%d", xcnt);
		/**/
        strcat(temp, ",");
        strcat(temp, p_string);
    /* --- save p_string to array --- */
        len = strlen(temp);
        size = len + 1;
        ii = line_ndx;
        array1[ii] = realloc(array1[ii], size * sizeof(char));
        strcpy(array1[line_ndx], temp);   		/* store to array */
    }
   /* printf("p_string: %s", temp); */
}
/*---------- end ScanDim ----------*/


void ScanStrArray()
{   char ch, varname[VAR_NAME];
    int pi, len, type;

    len = strlen(p_string);
    pi = e_pos;
    pi = get_paren(pi, len);
    e_pos = pi;
    ScanArrayParam();			/* assign variables: abc$(1,3,n) */
		/**/
    pi = e_pos;
    pi = get_rightExp(pi);			/* jump pi over this operator */
    ch = p_string[pi];
    while((ch != '\n') && (pi < len))
    {   e_pos = pi;
        if(ch == '\"')				/* found a quoted string */
        {   GetNewVar();				/* get new varname */
        }
        else if(isalpha(ch))
        {   strcpy(varname, get_varname());		/* get varname */
			/**/
            type = get_vtype(pi);
            if(type == 6)
            {   pi = e_pos;
                pi = get_paren(pi, len);
                ScanArrayParam();
            }
            else
            {   Sav_String(varname);
            }
        }
        else if(isdigit(ch))			/* a string function number */
        {   len = scanStr_funct(len);
        }
        pi = e_pos;
        pi = get_rightExp(pi);
        ch = p_string[pi];
   /* printf("ch=%c pi=%d\n", ch, pi); */
    }
 /*  printf("%s", p_string); */
}
/*---------- end ScanStrArray ----------*/


void ScanArrayParam()
{   char ch;
    int pi;

    pi = e_pos;
    ch = p_string[pi];
    while(ch != ')')
    {   e_pos = pi;
        if(isalpha(ch))
        {   AddNewVar();
            pi = e_pos;
        }
        else
        {   pi++;
        }
        ch = p_string[pi];
    }
    e_pos = pi;
}
/*---------- end ScanArrayParam ----------*/


